#!/usr/bin/python
from network import WLAN
from socket import socket
import socket
import struct
from network import LoRa
import machine
import utime
from machine import RTC
import os
import urequests

host = "192.168.0.128"
port = 21563
buf = 1024
addr = (host,port)

wlan = WLAN(mode=WLAN.STA)
wlan.connect(ssid='SK@unifi', auth=(WLAN.WPA2, '!2#4%6&8(0'), timeout=30000)

while not wlan.isconnected():
	machine.idle()

rtc = RTC()
rtc.init((2018,10,04,17,57,40))
print(rtc.now())
ctime = str(rtc.now())

filename = ctime + ".txt"
_LORA_PKG_FORMAT = "!BB%ds"
_LORA_PKG_ACK_FORMAT = "BBB"
lora = LoRa(mode=LoRa.LORA, rx_iq=True, region=LoRa.AS923)
lora_sock = socket.socket(socket.AF_LORA, socket.SOCK_RAW)
lora_sock.setblocking(False)

while (True):
    recv_pkg = lora_sock.recv(512)
    if (len(recv_pkg) > 2):
        recv_pkg_len = recv_pkg[1]
        device_id, pkg_len, msg = struct.unpack(_LORA_PKG_FORMAT % recv_pkg_len, recv_pkg)
        print('getting messages')
        print('Device: %d - Pkg:  %s' % (device_id, msg))
        print('got messages')
        file = open(filename, "w")
        file.write(msg)
        response = urequests.get("http://localhost/ksn/server.php?data=" + msg)
        response.close()

        if wlan.isconnected():
        	s = socket.socket(socket.AF_INET,socket.SOCK_DGRAM)
        	s.sendto(msg,addr)
        	print ("Sending message '",msg,"'.....")
        s.close()
        file.close()
        print("writing complete")
        ack_pkg = struct.pack(_LORA_PKG_ACK_FORMAT, device_id, 1, 200)
        lora_sock.send(ack_pkg)

